//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////         init the hole extension          //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                    MODIFY     THE     WINDOW     LAYOUT                                                               //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// find msgIdentity Element and give Parents a name ...
var Obj_MsgIdentity = document.getElementById("msgIdentity");

var parent_hbox = Obj_MsgIdentity.parentNode;
parent_hbox.setAttribute("id", "msgIdentityHbox");

var new_vbox = document.createElement("vbox");
new_vbox.setAttribute("id", "msgIdentityVbox");

parent_hbox.replaceChild(new_vbox, Obj_MsgIdentity);

new_vbox.appendChild(Obj_MsgIdentity);

// replace FillIdentityListPopup with our own version to prevent showing
// Virtual Identity Accounts in different (parallel) MailCompose Dialogs
dump("## V_Identity: replace FillIdentityListPopup\n");
FillIdentityListPopup = function (popup) {VIdentity_FillIdentityListPopup(popup);}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                      INITIALIZE SOME GLOBAL VARIABLES                                                         //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var VIdent_Prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

// some variables for the 'smart reply' feature
var addresses = {}; var names = {}; var fullNames = {}; // these store all different addresses
var new_email = null; var new_fullName = null;		// this vars contain the choosen 'smart reply' adress
var smart_reply = null;

var active = null; // stores if the extension is active, functions are replaced etc.

var smart_reply_keep_closed = null; // hiding the extension area if choosen in preferences

// Those variables keep pointers to original functions which might get replaced later
var vident_origGenericSendMessage = null;
var vident_origMsgComposeCloseWindow = null;
var vident_origLoadIdentity = null;

// The created account ;)
var VIdent_Account = null;

// The single Menu-Item in the Identities-Dropdown-Menu to store VirtualIdentity
// enables possibility to open and close the extension area
var MenuItem = null;	

// stores the Identity which is overwritten by Virtual Identity
// maybe we need this Identity to use the Information where to place a copy of the sended mail etc.
var FormerIdentity = null;

// store if the following Listener is activated
var StateListenerRegistered = null;
// This Listener is used if you send a mail and will register if this is done succesfully
// if so it will remove the VirtualIdentity and Close the Window
var VIdentComposeStateListener = {
  NotifyComposeFieldsReady: function() { dump("## V_Identity: NotifyComposeFieldsReady\n"); },
  ComposeProcessDone: function(aResult) {
    if (aResult== Components.results.NS_OK) {
	dump("## V_Identity: StateListener reports ComposeProcessDone\n");
	//~ confirm("## V_Identity: StateListener reports ComposeProcessDone");
	VIdentity_Cleanup(); MsgComposeCloseWindow(true); }
  },
  SaveInFolderDone: function(folderURI) { dump("## V_Identity: SaveInFolderDone\n"); }
};

// get a reference to the prompt service component.
//~ var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                      REPLACE SOME WINDOW FUNCTIONS                                                             //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// replace ComposeLoad with our own version to see if smart reply is needed
window.onload=VIdentity_ComposeLoad

// replace MsgComposeCloseWindow with our own version to get rid of the old account
if (!vident_origMsgComposeCloseWindow) {
	dump("## V_Identity: replace MsgComposeCloseWindow\n");
	vident_origMsgComposeCloseWindow = MsgComposeCloseWindow;
	MsgComposeCloseWindow = function (recycleIt) {VIdentity_MsgComposeCloseWindow(recycleIt);}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////         init done                                                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// After Loading the MessageComposeDialog, check if SmartReply is Needed
function VIdentity_ComposeLoad() {
	ComposeLoad();
	
	// check if smart reply is activated
	//~ var VIdent_Prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var smart_reply;
	try { smart_reply = VIdent_Prefs.getBoolPref("virtual_identity.smart_reply"); }
	catch (ex) { smart_reply = 1; }  // If option is still not set, think if its enabled
	
	if (smart_reply) v_identity_SmartReply();
}

// this is the callback-function from the multiple reply-dialog
function VIdentity_Reply(count) {
	if (active == null) {
		new_email = addresses.value[count];
		new_fullName = names.value[count];
		smart_reply = 1;
		dump("## V_Identity: replace with " + new_email + new_fullName + "\n");
		dump("## V_Identity: Smart Reply keep_closed " + smart_reply_keep_closed + "\n");
		try { smart_reply_keep_closed = VIdent_Prefs.getBoolPref("virtual_identity.smart_reply_keep_closed"); }
		catch (ex) { smart_reply_keep_closed = 0; }
		expand();
		smart_reply_keep_closed = 0;
	}
}

// this function checks if we have a reply-case and Smart-Reply should replace the Identity
function v_identity_SmartReply() {
	var params = window.arguments[0];
	
	// first check if this is a reply-case at all, if not, leave the function
	var type = params.type; var msgComposeType = Components.interfaces.nsIMsgCompType;
	if (!(type == msgComposeType.Reply || type == msgComposeType.ReplyAll ||
			type == msgComposeType.ReplyToGroup || type == msgComposeType.ReplyToSender || 
					type == msgComposeType.ReplyToSenderAndGroup)) return;

	// if there is no ID of the original Message  (Why?) leave the function
	var uri = params.originalMsgURI; 
	if (!uri) return;

	// get former mail-header
	var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();
	messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);
	var hdr = messenger.messageServiceFromURI(uri).messageURIToMsgHdr(uri);

	// parse former header into global variables
	var all_emails = (type == msgComposeType.Template) ? hdr.author : hdr.recipients + ", " + hdr.ccList;
	var hdrParser = Components.classes["@mozilla.org/messenger/headerparser;1"].getService(Components.interfaces.nsIMsgHeaderParser);
	var numAddresses = hdrParser.parseHeadersWithArray(all_emails, addresses, names, fullNames);

	var count = numAddresses;
	var found = null;
	while (count--) { // check if recent email-address (pre-choosen identity) is found in 
			  // any email in the former mail-header
		if (found = (params.identity.email == addresses.value[count])) break; // direct hit
	}
	if (!found) {
		var ask_always; var single_domain; var single_domainname;
		try { ask_always = VIdent_Prefs.getBoolPref("virtual_identity.smart_reply_ask_always"); }
		catch (ex) { aks_always = 0; }
		try { single_domain = VIdent_Prefs.getBoolPref("virtual_identity.smart_reply_single_domain"); }
		catch (ex) { single_domain = 0; }
		try { single_domainname = VIdent_Prefs.getCharPref("virtual_identity.smart_reply_single_domainname"); }
		catch (ex) { single_domainname = ""; }

		count = numAddresses; found = 0;
		while (single_domain && single_domainname && count--) { // check if any email-address matches domain
			var address = addresses.value[count].toLowerCase();
			var index = address.indexOf("@");
			var addressdomainname = address.substring(index+1);
			dump("## V_Identity: comparing " + addressdomainname + " and " + single_domainname + "\n");
			if (index != -1 && addressdomainname == single_domainname) {
				dump("## V_Identity: found \n");
				if (!found) found = count;
				else found = -1;
			}
		}
		dump("## V_Identity: found=" + found + "\n");
		
		//~ datetoday = new Date(); timenow=datetoday.getTime();
		
		if (found > 0) VIdentity_Reply(found);
		else if (numAddresses == 1 && !ask_always) VIdentity_Reply(0);
		// if there is more than one posible email (or the user likes to be asked anyway), ask the user to choose one.
		else if (numAddresses > 0) window.openDialog("chrome://v_identity/content/v_reply.xul",0, // give the Dialog a unique id
				"chrome", numAddresses, addresses, VIdentity_Reply);
	}
}

// This function replaces FillIdentityListPopup with our own version to prevent showing
// Virtual Identity Accounts in different (parallel) MailCompose Dialogs
function VIdentity_FillIdentityListPopup(popup)
{
  var accounts = queryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);
  accounts.sort(compareAccountSortOrder);

  for (var i in accounts) {
    var server = accounts[i].incomingServer;
    
    // changed next line to ignore (other) VirtualIdentity Accounts
    if (!server || server.hostName == "VirtualIdentity") continue;
    
    var identites = queryISupportsArray(accounts[i].identities, Components.interfaces.nsIMsgIdentity);
    for (var j in identites) {
      var identity = identites[j];
      var item = document.createElement("menuitem");
      item.className = "identity-popup-item";
      item.setAttribute("label", identity.identityName);
      item.setAttribute("value", identity.key);
      item.setAttribute("accountkey", accounts[i].key);
      item.setAttribute("accountname", " - " + server.prettyName);
      
      popup.appendChild(item);
    }
  }
}


// someone clicked on the expand-sign so show the extension-area or hide it
// depending on the former state
function expand()
{
	if (active == null) {
		// FIRST CALL: initialize the hole Extension
		if (replaceGenericFuntions() == "true") {
			initNewFields();
			active = 1;
		}
		else {
		  Obj_expandButton.setAttribute("hidden", "true");
		  //~ dump("## V_Identity: WARNING:Cannot hook message sending -- you will not be able to fake Identitys\n");
		  //~ promptService.alert(window,"Error","Virtual Identity wasnt able to adapt some Thunderbird-functions\n" +
					//~ "so you wont be able to fake Identity. If you like to help solving the problem,\n" +
					//~ "please report this bug to v_identity_bug_report@absorb.it");
		}
	}
 	
	var Obj_SendMsgHeaders = document.getElementById("SendMsgHeaders");
	// show extension, dont show it if smart-reply keep_closed option is choosen
	if (Obj_SendMsgHeaders.getAttribute("hidden") == "true" && !smart_reply_keep_closed ) {
		if (active == 1) { showExtension(); }
	}
	else {
		hideExtension();
		updateDropdownMenu();
	}
}


function showExtension()
{	
	var Obj_expandButton = document.getElementById("expandButton");
	var Obj_SendMsgHeaders = document.getElementById("SendMsgHeaders");
	var Obj_MsgIdentity = document.getElementById("msgIdentity");
	Obj_SendMsgHeaders.setAttribute("hidden", "false");
	Obj_MsgIdentity.setAttribute("hidden", "true");
	Obj_MsgIdentity.setAttribute("style", "background-color:transparent;")
	Obj_expandButton.setAttribute("class","expandHeaderViewButton");
}

function hideExtension()
{
	var Obj_expandButton = document.getElementById("expandButton");
	var Obj_SendMsgHeaders = document.getElementById("SendMsgHeaders");
	var Obj_MsgIdentity = document.getElementById("msgIdentity");
	Obj_SendMsgHeaders.setAttribute("hidden", "true");
	Obj_MsgIdentity.setAttribute("hidden", "false");
	Obj_MsgIdentity.setAttribute("style", "")
	Obj_expandButton.setAttribute("class","collapsedHeaderViewButton");
}

function replaceGenericFuntions()
{
	// some code inspired and borrowed from enigmail
	if (typeof(GenericSendMessage)=="function" && typeof(LoadIdentity)=="function") {
	  // replace GenericSendMessage with our own version
	  if (!vident_origGenericSendMessage) {
		dump("## V_Identity: replace GenericSendMessage\n");
		vident_origGenericSendMessage = GenericSendMessage;
		GenericSendMessage = function (msgType) {VIdentity_GenericSendMessage(msgType);}
	  }
	  // replace LoadIdentity with our own version
	  if (!vident_origLoadIdentity) {
		dump("## V_Identity: replace LoadIdentity\n");
		vident_origLoadIdentity = LoadIdentity;
		LoadIdentity = function (startup) {VIdentity_LoadIdentity(startup);}
	  }
	  return "true"}
	else {
	  dump("## V_Identity ERROR: could not replace your SendMessage and/or LoadIdentity Function, aborting\n"); 
	  return "false";
	  }
}

function createVIdentity_Account()
{
  if (VIdent_Account) return; // if the Account is still created, then leave all like it is
  var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
  
  VIdent_Account = AccManager.createAccount();
  var VIdent_Identity = AccManager.createIdentity();
  
  VIdent_Account.addIdentity(VIdent_Identity);
  
  var Number = getNewAccountNumber();
  
  var server = AccManager.createIncomingServer("user"+Number,"VirtualIdentity","pop3");
  server.prettyName = document.getElementById("prettyName-Prefix").getAttribute("label") + Number;
  VIdent_Account.incomingServer = server;
  
  // remove the folder created with this account - it should never be used to store mails
  VIdent_Account.incomingServer.rootFolder.Delete();
  
  dump("## V_Identity: New Account created "+server.prettyName+"\n");
}

// gives some vsalues to the new fields which are shown after opening the extension-area
function initNewFields()
{
	var identityElement_fullName = document.getElementById("msg_fullName");
	// if smart_identity has set new_fullName, use thisone, else use gCurrentId-one
	if (smart_reply) { identityElement_fullName.value = new_fullName; new_fullName = null;}
	else identityElement_fullName.value = gCurrentIdentity.fullName;
	
	var identityElement_useremail = document.getElementById("msg_useremail");
	// if smart_identity has set new_fullName, use thisone, else use gCurrentId-one
	if (smart_reply) { identityElement_useremail.value = new_email; new_email = null;}
	else identityElement_useremail.value = gCurrentIdentity.email;
	
	smart_reply = null;
	
	loadSMTP_server_list();
}

// if the windows gets closed, this is the way to get rid of the account.
function VIdentity_MsgComposeCloseWindow(recycleIt)
{
  dump("## V_Identity: MsgComposeCloseWindow\n");
  VIdentity_Cleanup();
  window.close();
}

// if VIdentity Extension is closed after the extension area was opened at least once,
// remove the Virtual Account if a different (usual) Account is choosen in the dropdown-menu
// The funciotn replaces the original LoadIdentity, which is called everytime you change 
// the dropdown-menu value
function VIdentity_LoadIdentity(startup)
{
	dump("## V_Identity: Identity changed\n");
	var identityList = document.getElementById("msgIdentity");
	if (identityList.value != "")
		{ VIdentity_Cleanup(); LoadIdentity(startup);}
}

// Clean all the things I had changed (expecpt the FillIdentityListPopup)
function VIdentity_Cleanup()
{
  dump("## V_Identity: Cleanup\n");
  VIdentity_Cleanup_AccountAndListener();
  
  // restore functions
  if (vident_origGenericSendMessage) { GenericSendMessage = vident_origGenericSendMessage; vident_origGenericSendMessage = null; }
  if (vident_origMsgComposeCloseWindow) { MsgComposeCloseWindow = vident_origMsgComposeCloseWindow; vident_origMsgComposeCloseWindow = null; }
  if (vident_origLoadIdentity) { LoadIdentity = vident_origLoadIdentity; vident_origLoadIdentity = null; }
  
  // remove Menuitem
  if (MenuItem) {
    var identityListPopup = document.getElementById("msgIdentityPopup");
    identityListPopup.removeChild(MenuItem);
    MenuItem = null;
  }
  if (FormerIdentity) FormerIdentity = null;
  
  active = null;
  hideExtension();
}

// removes the account and the Listener
function VIdentity_Cleanup_AccountAndListener()
{
  // remove temporary Account
  if (VIdent_Account) {
    var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
    dump("## V_Identity: Account " + VIdent_Account.incomingServer.prettyName + " removed\n")
    VIdent_Account.incomingServer.rootFolder.Delete();
    AccManager.removeAccount(VIdent_Account);
    VIdent_Account = null;
  }

  // remove Listener  
  if (StateListenerRegistered) {
	gMsgCompose.UnregisterStateListener(VIdentComposeStateListener);
	StateListenerRegistered = null;
  }
}


function VIdentity_GenericSendMessage( msgType )
{
	dump("## V_Identity: VIdentity_GenericSendMessage\n");
	// dont allow user to fake identity if Message is not sended NOW!!!!
	if (msgType != nsIMsgCompDeliverMode.Now) {
		var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
		var server = AccManager.defaultAccount.incomingServer.prettyName
		var name = AccManager.defaultAccount.defaultIdentity.fullName
		var email = AccManager.defaultAccount.defaultIdentity.email

		//Get the bundled string file.
		var stringBundle = document.getElementById("vIdentBundle");
		
		if (confirm(stringBundle.getString("vident.sendLater.warning") +
			stringBundle.getString("vident.sendLater.prefix") +
			name + " " + email + " [" + server + "]" + stringBundle.getString("vident.sendLater.postfix")))
			{
				VIdentity_Cleanup();
				setDefaultMenuEntry();
				GenericSendMessage( msgType );
			}
		else { return; }
		}
	else
        {
		createVIdentity_Account();
		storeIdentity();
		setMsgIdentityMenu();
		gMsgCompose.RegisterStateListener(VIdentComposeStateListener);
		StateListenerRegistered = 1;
		vident_origGenericSendMessage( msgType );
		if (window.cancelSendMessage) {
			VIdentity_Cleanup_AccountAndListener();
			dump("## V_Identity: SendMessage cancelled\n");
		}
	}
}


function setDefaultMenuEntry()
{
	var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
	// set MenuEntry to default one
	var identityList = document.getElementById("msgIdentity");
	identityList.value = AccManager.defaultAccount.defaultIdentity.key;
	identityList.setAttribute("label", AccManager.defaultAccount.defaultIdentity.identityName);
	identityList.setAttribute('accountname', " - " +  AccManager.defaultAccount.incomingServer.prettyName);
	identityList.setAttribute("accountkey", AccManager.defaultAccount.key);
}

function setMsgIdentityMenu()
{
  if (!MenuItem) { updateDropdownMenu(); };
  
  //~ identityListPopup.removeChild(MenuItem);
  MenuItem.setAttribute("label", VIdent_Account.defaultIdentity.identityName);
  MenuItem.setAttribute("accountname", " - " +  VIdent_Account.incomingServer.prettyName);
  MenuItem.setAttribute("accountkey", VIdent_Account.key);
 
  // set the  account name on the menu list value.
  var identityList = document.getElementById("msgIdentity");
  identityList.setAttribute("label", document.getElementById("menuListItem-Head").getAttribute("label") + VIdent_Account.defaultIdentity.identityName);
  identityList.setAttribute('accountname', " - " +  VIdent_Account.incomingServer.prettyName);
  identityList.setAttribute("accountkey", VIdent_Account.key);
  identityList.value = VIdent_Account.defaultIdentity.key;
}


function updateDropdownMenu()
{
  var curIdentity = getCurrentIdentity();
  if (curIdentity) FormerIdentity = curIdentity; // We have to store the former Identity to use the settings of this later
  var identityListPopup = document.getElementById("msgIdentityPopup");
  var identityList = document.getElementById("msgIdentity");
  var identityElement_fullName = document.getElementById("msg_fullName");
  var identityElement_useremail = document.getElementById("msg_useremail");

  if (!MenuItem) {
	// add entry to identityList
	MenuItem = document.createElement("menuitem");
	MenuItem.className = "identity-popup-item";
	identityListPopup.appendChild(MenuItem);
  }
  
  // set the account name in the choosen menu item
  MenuItem.setAttribute("label", identityElement_fullName.value + " <" + identityElement_useremail.value + ">");
  MenuItem.setAttribute("accountname", " - " + document.getElementById("prettyName-Prefix").getAttribute("label"));
  MenuItem.setAttribute("accountkey", "");
 
  // set the account name on the menu list value.
  identityList.setAttribute("label", identityElement_fullName.value + " <" + identityElement_useremail.value + ">");
  identityList.setAttribute('accountname', " - " + document.getElementById("prettyName-Prefix").getAttribute("label"));
  identityList.setAttribute("accountkey", "");
  identityList.value = "";
}

function getCurrentIdentity()
{
    // fill in Identity combobox
    var identityList = document.getElementById("msgIdentity");

    var identityKey = identityList.value;

    var identity = gAccountManager.getIdentity(identityKey);

    return identity;
}


function storeIdentity()
{
  var identityElement_fullName = document.getElementById("msg_fullName");
  var identityElement_useremail = document.getElementById("msg_useremail");
  var serverMenu = document.getElementById("smtp_server_list");
		
  VIdent_Account.defaultIdentity.setUnicharAttribute("fullName", identityElement_fullName.value);
  VIdent_Account.defaultIdentity.setCharAttribute("useremail", identityElement_useremail.value);
  
  if (serverMenu.selectedItem)
   VIdent_Account.defaultIdentity.smtpServerKey = serverMenu.selectedItem.getAttribute('key');
  //~ else promptService.alert(window,"Error","This shouldnt happen: SMTP-Server unselected.\n" +
					//~ "If you like to help solving the problem,\n" +
					//~ "please report this bug to v_identity_bug_report@absorb.it");
  dump("## V_Identity: Stored VirtualIdentity (name " + VIdent_Account.defaultIdentity.fullName + " email " +
	VIdent_Account.defaultIdentity.email + " smtp " + VIdent_Account.defaultIdentity.smtpServerKey +")\n");
	
  //~ var VIdent_Prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  
  var doFcc; try { doFcc = VIdent_Prefs.getBoolPref("virtual_identity.doFcc"); } catch (ex) {doFcc = true;}
  var fccFolder; try { fccFolder = VIdent_Prefs.getCharPref("virtual_identity.fcc_folder"); } catch (ex) { fccFolder = "";}
  var fccFolderPickerMode; try { fccFolderPickerMode = VIdent_Prefs.getCharPref("virtual_identity.fcc_folder_picker_mode"); } 
		catch (ex) {fccFolderPickerMode = "3";}
  

  if (doFcc) {
	//~ dump ("## V_Identity: preparing Fcc\n");
	switch (fccFolderPickerMode) 
	{
	    case "2"  :
	    	dump ("## V_Identity: preparing Fcc --- use Settings of Default Account\n");
		var AccManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
		VIdent_Account.defaultIdentity.doFcc = AccManager.defaultAccount.defaultIdentity.doFcc;
		VIdent_Account.defaultIdentity.fccFolder = AccManager.defaultAccount.defaultIdentity.fccFolder;
		VIdent_Account.defaultIdentity.fccFolderPickerMode = AccManager.defaultAccount.defaultIdentity.fccFolderPickerMode;
		break;
	    case "3"  :
		dump ("## V_Identity: preparing Fcc --- use Settings of Modified Account\n");
		if (!FormerIdentity)  FormerIdentity = getCurrentIdentity();
		if (FormerIdentity) {
			VIdent_Account.defaultIdentity.doFcc = FormerIdentity.doFcc;
			VIdent_Account.defaultIdentity.fccFolder = FormerIdentity.fccFolder;
			VIdent_Account.defaultIdentity.fccFolderPickerMode = FormerIdentity.fccFolderPickerMode;
		}
		break;
	    default  :
		dump ("## V_Identity: preparing Fcc --- use Virtual Identity Settings\n");
		VIdent_Account.defaultIdentity.doFcc = doFcc;
		VIdent_Account.defaultIdentity.fccFolder = fccFolder;
		VIdent_Account.defaultIdentity.fccFolderPickerMode = fccFolderPickerMode;
		break;
	}
  }
  else {
	dump ("## V_Identity: dont performing Fcc\n");
	VIdent_Account.defaultIdentity.doFcc = false;
	}
  dump("## V_Identity: Stored (doFcc " + VIdent_Account.defaultIdentity.doFcc + " fccFolder " +
	VIdent_Account.defaultIdentity.fccFolder + " fccFolderPickerMode " +
	VIdent_Account.defaultIdentity.fccFolderPickerMode + ")\n");
}

//~ Checks if there is stil another VIdentity Account and creates a new one
function getNewAccountNumber()
{
  var accounts = queryISupportsArray(gAccountManager.accounts, Components.interfaces.nsIMsgAccount);
  
  var FreeVIdentityNumber = 0
  var i = 0
  while (i < accounts.length) {
    var server = accounts[i].incomingServer;
    if (server && server.hostName == "VirtualIdentity" 
	&& server.prettyName == document.getElementById("prettyName-Prefix").getAttribute("label") + FreeVIdentityNumber) {
		FreeVIdentityNumber++; i = 0;}
    else { i++; }
    }
  return FreeVIdentityNumber;
}

// this it what it looks like ;)
function open_homepage()
{
	var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();
	messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);
	messenger.launchExternalURL("http://absorb.it/hacked/thunderbird/v_identity.html");
}

// some code borrowed from showsmtpuser extension
function loadSMTP_server_list()
{
	var smtpService
	if (!smtpService)
        smtpService = Components.classes["@mozilla.org/messengercompose/smtp;1"].getService(Components.interfaces.nsISmtpService);
	var serverList = document.getElementById("smtp_server_list_popup");
	while (serverList.hasChildNodes())
		serverList.removeChild(serverList.lastChild);
	var serverMenu = document.getElementById("smtp_server_list");
    
	if (getCurrentIdentity().smtpServerKey) 
		var idserver = smtpService.getServerByKey(getCurrentIdentity().smtpServerKey);
	else	var idserver = smtpService.defaultServer;

	var defaultServer = smtpService.defaultServer;
	var servers = smtpService.smtpServers
    
	var serverCount = servers.Count();

	for (var i=0 ; i<serverCount; i++) {
		var server = servers.QueryElementAt(i, Components.interfaces.nsISmtpServer);
		if (!server.redirectorType) 
		{
		  var listitem = createSmtpListItemx(server);
		  serverList.appendChild(listitem);
		  // set choosen default server 
		  if (idserver == server) serverMenu.selectedItem = listitem;
		}
	}
	serverMenu.setAttribute("label", getNewHostnamex(idserver));
	
}

function createSmtpListItemx(server) {
    var listitem = document.createElement("menuitem");

    var hostname = getNewHostnamex(server);
    
    listitem.setAttribute("label", hostname);
    listitem.setAttribute("key", server.key);
    // give it some unique id
    listitem.id = "smtpServer." + server.key;

    return listitem;
}


function getNewHostnamex(server)
{
    var showAlias = true;
    var showUsername = true;
    var hideUsername = true;

    
    // reuse Preferences from ssun
    try { showAlias = prefService.getBoolPref("ssun.showalias"); } catch (ex) {}
    try { showUsername = prefService.getBoolPref("ssun.showusername"); } catch (ex) {}
    try { hideUsername = prefService.getBoolPref("ssun.hideusername"); } catch (ex) {}

    var hostname = server.hostname;
    var port = "";

    if (server.port)
      port = ":" + server.port;

    // SSUN: Get server alias
    var alias = "";
    if (showAlias) {
        try { alias = prefService.getCharPref("ssun." + server.key + ".alias"); } catch (ex) {}
        if (alias) {
            hostname = alias;
        } else {
            hostname += port;
        }
    } else {
        hostname += port;
    }

    // SSUN: Add username
    if (showUsername && (!showAlias || (showAlias && (!alias || !hideUsername))) && server.authMethod && server.username)
      hostname += " (" + server.username + ")";

    return hostname
}
